#    software histogramming

loadsource hist

set frametitle "Software Histogramming"
set icontitle "Histogramming"

if {[info exists env(SHistServer)]} then {set resource $env(SHistServer)} else {set resource VMEhist}
set SpectrumServer $resource

set resources [list $SpectrumServer]
set numresources [llength $resources]


proc make-resource-list {} {}

proc execute-spectrum {n action} {
  global resource
  global debug

  set server $resource

  switch $action {
     create {
        set range [range-of $n]
        if {$debug} then {insert-debug "create spectrum :range $range :name '$n' "}
        set z [catch {eg "(spectrum :path '/$server' :range $range :name '$n' !new)" } m]
#    Allow "Spectrum already exists" so that further spectra can be created
        if {$z == 0} then {inform sys map_needed}
        if {$z!=0 && $m==0x30004} then {set z 0}
     }
     delete {
        if {$debug} then {insert-debug "delete spectrum  :name '$n' "}
        set z [catch {eg "(spectrum :path '/$server' :name '$n' !delete)"} m]
# Allow "Pathname Invalid" so that further spectra can be deleted
        if {$z!=0 && $m==0x30004} then {set z 0}
     }
     clear {
        if {$debug} then {insert-debug "clear spectrum  :name '$n' "}
        set z [catch {eg "(spectrum :path '/$server' :name '$n' !zero)"} m]
     }
  }
  if {$z!=0} then {
    display-eg-error-report self $m "Attempting to " $action "spectrum" $n
    clear-footer
    error $m
  }
}
